// Code generated by go-swagger; DO NOT EDIT.

package access_control

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/grafana/grafana-openapi-client-go/models"
)

// NewListTeamsRolesParams creates a new ListTeamsRolesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewListTeamsRolesParams() *ListTeamsRolesParams {
	return &ListTeamsRolesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewListTeamsRolesParamsWithTimeout creates a new ListTeamsRolesParams object
// with the ability to set a timeout on a request.
func NewListTeamsRolesParamsWithTimeout(timeout time.Duration) *ListTeamsRolesParams {
	return &ListTeamsRolesParams{
		timeout: timeout,
	}
}

// NewListTeamsRolesParamsWithContext creates a new ListTeamsRolesParams object
// with the ability to set a context for a request.
func NewListTeamsRolesParamsWithContext(ctx context.Context) *ListTeamsRolesParams {
	return &ListTeamsRolesParams{
		Context: ctx,
	}
}

// NewListTeamsRolesParamsWithHTTPClient creates a new ListTeamsRolesParams object
// with the ability to set a custom HTTPClient for a request.
func NewListTeamsRolesParamsWithHTTPClient(client *http.Client) *ListTeamsRolesParams {
	return &ListTeamsRolesParams{
		HTTPClient: client,
	}
}

/*
ListTeamsRolesParams contains all the parameters to send to the API endpoint

	for the list teams roles operation.

	Typically these are written to a http.Request.
*/
type ListTeamsRolesParams struct {

	// Body.
	Body *models.RolesSearchQuery

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the list teams roles params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListTeamsRolesParams) WithDefaults() *ListTeamsRolesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the list teams roles params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListTeamsRolesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the list teams roles params
func (o *ListTeamsRolesParams) WithTimeout(timeout time.Duration) *ListTeamsRolesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the list teams roles params
func (o *ListTeamsRolesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the list teams roles params
func (o *ListTeamsRolesParams) WithContext(ctx context.Context) *ListTeamsRolesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the list teams roles params
func (o *ListTeamsRolesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the list teams roles params
func (o *ListTeamsRolesParams) WithHTTPClient(client *http.Client) *ListTeamsRolesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the list teams roles params
func (o *ListTeamsRolesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the list teams roles params
func (o *ListTeamsRolesParams) WithBody(body *models.RolesSearchQuery) *ListTeamsRolesParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the list teams roles params
func (o *ListTeamsRolesParams) SetBody(body *models.RolesSearchQuery) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *ListTeamsRolesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
