// Code generated by go-swagger; DO NOT EDIT.

package enterprise

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewEnableDataSourceCacheParams creates a new EnableDataSourceCacheParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewEnableDataSourceCacheParams() *EnableDataSourceCacheParams {
	return &EnableDataSourceCacheParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewEnableDataSourceCacheParamsWithTimeout creates a new EnableDataSourceCacheParams object
// with the ability to set a timeout on a request.
func NewEnableDataSourceCacheParamsWithTimeout(timeout time.Duration) *EnableDataSourceCacheParams {
	return &EnableDataSourceCacheParams{
		timeout: timeout,
	}
}

// NewEnableDataSourceCacheParamsWithContext creates a new EnableDataSourceCacheParams object
// with the ability to set a context for a request.
func NewEnableDataSourceCacheParamsWithContext(ctx context.Context) *EnableDataSourceCacheParams {
	return &EnableDataSourceCacheParams{
		Context: ctx,
	}
}

// NewEnableDataSourceCacheParamsWithHTTPClient creates a new EnableDataSourceCacheParams object
// with the ability to set a custom HTTPClient for a request.
func NewEnableDataSourceCacheParamsWithHTTPClient(client *http.Client) *EnableDataSourceCacheParams {
	return &EnableDataSourceCacheParams{
		HTTPClient: client,
	}
}

/*
EnableDataSourceCacheParams contains all the parameters to send to the API endpoint

	for the enable data source cache operation.

	Typically these are written to a http.Request.
*/
type EnableDataSourceCacheParams struct {

	// DataSourceUID.
	DataSourceUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the enable data source cache params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *EnableDataSourceCacheParams) WithDefaults() *EnableDataSourceCacheParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the enable data source cache params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *EnableDataSourceCacheParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the enable data source cache params
func (o *EnableDataSourceCacheParams) WithTimeout(timeout time.Duration) *EnableDataSourceCacheParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the enable data source cache params
func (o *EnableDataSourceCacheParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the enable data source cache params
func (o *EnableDataSourceCacheParams) WithContext(ctx context.Context) *EnableDataSourceCacheParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the enable data source cache params
func (o *EnableDataSourceCacheParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the enable data source cache params
func (o *EnableDataSourceCacheParams) WithHTTPClient(client *http.Client) *EnableDataSourceCacheParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the enable data source cache params
func (o *EnableDataSourceCacheParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDataSourceUID adds the dataSourceUID to the enable data source cache params
func (o *EnableDataSourceCacheParams) WithDataSourceUID(dataSourceUID string) *EnableDataSourceCacheParams {
	o.SetDataSourceUID(dataSourceUID)
	return o
}

// SetDataSourceUID adds the dataSourceUid to the enable data source cache params
func (o *EnableDataSourceCacheParams) SetDataSourceUID(dataSourceUID string) {
	o.DataSourceUID = dataSourceUID
}

// WriteToRequest writes these params to a swagger request
func (o *EnableDataSourceCacheParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param dataSourceUID
	if err := r.SetPathParam("dataSourceUID", o.DataSourceUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
