// Code generated by go-swagger; DO NOT EDIT.

package enterprise

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetDataSourceCacheConfigParams creates a new GetDataSourceCacheConfigParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetDataSourceCacheConfigParams() *GetDataSourceCacheConfigParams {
	return &GetDataSourceCacheConfigParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetDataSourceCacheConfigParamsWithTimeout creates a new GetDataSourceCacheConfigParams object
// with the ability to set a timeout on a request.
func NewGetDataSourceCacheConfigParamsWithTimeout(timeout time.Duration) *GetDataSourceCacheConfigParams {
	return &GetDataSourceCacheConfigParams{
		timeout: timeout,
	}
}

// NewGetDataSourceCacheConfigParamsWithContext creates a new GetDataSourceCacheConfigParams object
// with the ability to set a context for a request.
func NewGetDataSourceCacheConfigParamsWithContext(ctx context.Context) *GetDataSourceCacheConfigParams {
	return &GetDataSourceCacheConfigParams{
		Context: ctx,
	}
}

// NewGetDataSourceCacheConfigParamsWithHTTPClient creates a new GetDataSourceCacheConfigParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetDataSourceCacheConfigParamsWithHTTPClient(client *http.Client) *GetDataSourceCacheConfigParams {
	return &GetDataSourceCacheConfigParams{
		HTTPClient: client,
	}
}

/*
GetDataSourceCacheConfigParams contains all the parameters to send to the API endpoint

	for the get data source cache config operation.

	Typically these are written to a http.Request.
*/
type GetDataSourceCacheConfigParams struct {

	// DataSourceUID.
	DataSourceUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get data source cache config params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetDataSourceCacheConfigParams) WithDefaults() *GetDataSourceCacheConfigParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get data source cache config params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetDataSourceCacheConfigParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get data source cache config params
func (o *GetDataSourceCacheConfigParams) WithTimeout(timeout time.Duration) *GetDataSourceCacheConfigParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get data source cache config params
func (o *GetDataSourceCacheConfigParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get data source cache config params
func (o *GetDataSourceCacheConfigParams) WithContext(ctx context.Context) *GetDataSourceCacheConfigParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get data source cache config params
func (o *GetDataSourceCacheConfigParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get data source cache config params
func (o *GetDataSourceCacheConfigParams) WithHTTPClient(client *http.Client) *GetDataSourceCacheConfigParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get data source cache config params
func (o *GetDataSourceCacheConfigParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDataSourceUID adds the dataSourceUID to the get data source cache config params
func (o *GetDataSourceCacheConfigParams) WithDataSourceUID(dataSourceUID string) *GetDataSourceCacheConfigParams {
	o.SetDataSourceUID(dataSourceUID)
	return o
}

// SetDataSourceUID adds the dataSourceUid to the get data source cache config params
func (o *GetDataSourceCacheConfigParams) SetDataSourceUID(dataSourceUID string) {
	o.DataSourceUID = dataSourceUID
}

// WriteToRequest writes these params to a swagger request
func (o *GetDataSourceCacheConfigParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param dataSourceUID
	if err := r.SetPathParam("dataSourceUID", o.DataSourceUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
