// Code generated by go-swagger; DO NOT EDIT.

package group_attribute_sync

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/grafana/grafana-openapi-client-go/models"
)

// NewCreateGroupMappingsParams creates a new CreateGroupMappingsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateGroupMappingsParams() *CreateGroupMappingsParams {
	return &CreateGroupMappingsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateGroupMappingsParamsWithTimeout creates a new CreateGroupMappingsParams object
// with the ability to set a timeout on a request.
func NewCreateGroupMappingsParamsWithTimeout(timeout time.Duration) *CreateGroupMappingsParams {
	return &CreateGroupMappingsParams{
		timeout: timeout,
	}
}

// NewCreateGroupMappingsParamsWithContext creates a new CreateGroupMappingsParams object
// with the ability to set a context for a request.
func NewCreateGroupMappingsParamsWithContext(ctx context.Context) *CreateGroupMappingsParams {
	return &CreateGroupMappingsParams{
		Context: ctx,
	}
}

// NewCreateGroupMappingsParamsWithHTTPClient creates a new CreateGroupMappingsParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateGroupMappingsParamsWithHTTPClient(client *http.Client) *CreateGroupMappingsParams {
	return &CreateGroupMappingsParams{
		HTTPClient: client,
	}
}

/*
CreateGroupMappingsParams contains all the parameters to send to the API endpoint

	for the create group mappings operation.

	Typically these are written to a http.Request.
*/
type CreateGroupMappingsParams struct {

	// Body.
	Body *models.GroupAttributes

	// GroupID.
	GroupID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create group mappings params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateGroupMappingsParams) WithDefaults() *CreateGroupMappingsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create group mappings params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateGroupMappingsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create group mappings params
func (o *CreateGroupMappingsParams) WithTimeout(timeout time.Duration) *CreateGroupMappingsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create group mappings params
func (o *CreateGroupMappingsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create group mappings params
func (o *CreateGroupMappingsParams) WithContext(ctx context.Context) *CreateGroupMappingsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create group mappings params
func (o *CreateGroupMappingsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create group mappings params
func (o *CreateGroupMappingsParams) WithHTTPClient(client *http.Client) *CreateGroupMappingsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create group mappings params
func (o *CreateGroupMappingsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create group mappings params
func (o *CreateGroupMappingsParams) WithBody(body *models.GroupAttributes) *CreateGroupMappingsParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create group mappings params
func (o *CreateGroupMappingsParams) SetBody(body *models.GroupAttributes) {
	o.Body = body
}

// WithGroupID adds the groupID to the create group mappings params
func (o *CreateGroupMappingsParams) WithGroupID(groupID string) *CreateGroupMappingsParams {
	o.SetGroupID(groupID)
	return o
}

// SetGroupID adds the groupId to the create group mappings params
func (o *CreateGroupMappingsParams) SetGroupID(groupID string) {
	o.GroupID = groupID
}

// WriteToRequest writes these params to a swagger request
func (o *CreateGroupMappingsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param group_id
	if err := r.SetPathParam("group_id", o.GroupID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
