// Code generated by go-swagger; DO NOT EDIT.

package group_attribute_sync

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/grafana/grafana-openapi-client-go/models"
)

// NewUpdateGroupMappingsParams creates a new UpdateGroupMappingsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateGroupMappingsParams() *UpdateGroupMappingsParams {
	return &UpdateGroupMappingsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateGroupMappingsParamsWithTimeout creates a new UpdateGroupMappingsParams object
// with the ability to set a timeout on a request.
func NewUpdateGroupMappingsParamsWithTimeout(timeout time.Duration) *UpdateGroupMappingsParams {
	return &UpdateGroupMappingsParams{
		timeout: timeout,
	}
}

// NewUpdateGroupMappingsParamsWithContext creates a new UpdateGroupMappingsParams object
// with the ability to set a context for a request.
func NewUpdateGroupMappingsParamsWithContext(ctx context.Context) *UpdateGroupMappingsParams {
	return &UpdateGroupMappingsParams{
		Context: ctx,
	}
}

// NewUpdateGroupMappingsParamsWithHTTPClient creates a new UpdateGroupMappingsParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateGroupMappingsParamsWithHTTPClient(client *http.Client) *UpdateGroupMappingsParams {
	return &UpdateGroupMappingsParams{
		HTTPClient: client,
	}
}

/*
UpdateGroupMappingsParams contains all the parameters to send to the API endpoint

	for the update group mappings operation.

	Typically these are written to a http.Request.
*/
type UpdateGroupMappingsParams struct {

	// Body.
	Body *models.GroupAttributes

	// GroupID.
	GroupID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update group mappings params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateGroupMappingsParams) WithDefaults() *UpdateGroupMappingsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update group mappings params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateGroupMappingsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update group mappings params
func (o *UpdateGroupMappingsParams) WithTimeout(timeout time.Duration) *UpdateGroupMappingsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update group mappings params
func (o *UpdateGroupMappingsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update group mappings params
func (o *UpdateGroupMappingsParams) WithContext(ctx context.Context) *UpdateGroupMappingsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update group mappings params
func (o *UpdateGroupMappingsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update group mappings params
func (o *UpdateGroupMappingsParams) WithHTTPClient(client *http.Client) *UpdateGroupMappingsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update group mappings params
func (o *UpdateGroupMappingsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the update group mappings params
func (o *UpdateGroupMappingsParams) WithBody(body *models.GroupAttributes) *UpdateGroupMappingsParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update group mappings params
func (o *UpdateGroupMappingsParams) SetBody(body *models.GroupAttributes) {
	o.Body = body
}

// WithGroupID adds the groupID to the update group mappings params
func (o *UpdateGroupMappingsParams) WithGroupID(groupID string) *UpdateGroupMappingsParams {
	o.SetGroupID(groupID)
	return o
}

// SetGroupID adds the groupId to the update group mappings params
func (o *UpdateGroupMappingsParams) SetGroupID(groupID string) {
	o.GroupID = groupID
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateGroupMappingsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param group_id
	if err := r.SetPathParam("group_id", o.GroupID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
