// Code generated by go-swagger; DO NOT EDIT.

package provisioning

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/grafana/grafana-openapi-client-go/models"
)

// ExportMuteTimingsReader is a Reader for the ExportMuteTimings structure.
type ExportMuteTimingsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ExportMuteTimingsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewExportMuteTimingsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 403:
		result := NewExportMuteTimingsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("[GET /v1/provisioning/mute-timings/export] ExportMuteTimings", response, response.Code())
	}
}

// NewExportMuteTimingsOK creates a ExportMuteTimingsOK with default headers values
func NewExportMuteTimingsOK() *ExportMuteTimingsOK {
	return &ExportMuteTimingsOK{}
}

/*
ExportMuteTimingsOK describes a response with status code 200, with default header values.

AlertingFileExport
*/
type ExportMuteTimingsOK struct {
	Payload *models.AlertingFileExport
}

// IsSuccess returns true when this export mute timings Ok response has a 2xx status code
func (o *ExportMuteTimingsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this export mute timings Ok response has a 3xx status code
func (o *ExportMuteTimingsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this export mute timings Ok response has a 4xx status code
func (o *ExportMuteTimingsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this export mute timings Ok response has a 5xx status code
func (o *ExportMuteTimingsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this export mute timings Ok response a status code equal to that given
func (o *ExportMuteTimingsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the export mute timings Ok response
func (o *ExportMuteTimingsOK) Code() int {
	return 200
}

func (o *ExportMuteTimingsOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /v1/provisioning/mute-timings/export][%d] exportMuteTimingsOk %s", 200, payload)
}

func (o *ExportMuteTimingsOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /v1/provisioning/mute-timings/export][%d] exportMuteTimingsOk %s", 200, payload)
}

func (o *ExportMuteTimingsOK) GetPayload() *models.AlertingFileExport {
	return o.Payload
}

func (o *ExportMuteTimingsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AlertingFileExport)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewExportMuteTimingsForbidden creates a ExportMuteTimingsForbidden with default headers values
func NewExportMuteTimingsForbidden() *ExportMuteTimingsForbidden {
	return &ExportMuteTimingsForbidden{}
}

/*
ExportMuteTimingsForbidden describes a response with status code 403, with default header values.

PermissionDenied
*/
type ExportMuteTimingsForbidden struct {
	Payload models.PermissionDenied
}

// IsSuccess returns true when this export mute timings forbidden response has a 2xx status code
func (o *ExportMuteTimingsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this export mute timings forbidden response has a 3xx status code
func (o *ExportMuteTimingsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this export mute timings forbidden response has a 4xx status code
func (o *ExportMuteTimingsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this export mute timings forbidden response has a 5xx status code
func (o *ExportMuteTimingsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this export mute timings forbidden response a status code equal to that given
func (o *ExportMuteTimingsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the export mute timings forbidden response
func (o *ExportMuteTimingsForbidden) Code() int {
	return 403
}

func (o *ExportMuteTimingsForbidden) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /v1/provisioning/mute-timings/export][%d] exportMuteTimingsForbidden %s", 403, payload)
}

func (o *ExportMuteTimingsForbidden) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /v1/provisioning/mute-timings/export][%d] exportMuteTimingsForbidden %s", 403, payload)
}

func (o *ExportMuteTimingsForbidden) GetPayload() models.PermissionDenied {
	return o.Payload
}

func (o *ExportMuteTimingsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
